import { getScrollNode } from "get-scroll-info";
import callfunc from "call-func";
import { easeInOutCubic, aniTimer } from "easing-lib";
var isRunning = [];
/**
 *  !!Important!! any logic change need take care isRunning
 */

var smoothScrollTo = function smoothScrollTo(to, duration, el, callback, scrollKey) {
  scrollKey = scrollKey || "scrollTop";
  var scrollNode = getScrollNode(el);

  var cb = function cb() {
    if (isRunning[scrollKey]) {
      isRunning[scrollKey] = false;
      callfunc(callback, [scrollNode]);
    }
  };

  var cancel = function cancel() {
    isRunning[scrollKey] = false;
  };

  if (isRunning[scrollKey]) {
    setTimeout(function () {
      scrollNode[scrollKey] = to;
      cb();
    }, 50);
    return cancel;
  }

  if (!duration) {
    duration = 900;
  }

  var from = scrollNode[scrollKey];
  var go = to - from;

  if (!go) {
    isRunning[scrollKey] = true;
    cb();
    return function () {};
  }

  aniTimer({
    isContinue: function isContinue(elapsedTime) {
      var progress = easeInOutCubic(elapsedTime, from, go, duration);
      scrollNode[scrollKey] = progress;

      if (isRunning[scrollKey]) {
        return true;
      }
    },
    cancel: function cancel() {
      return cb();
    },
    done: function done() {
      return cb();
    }
  }, duration);
  isRunning[scrollKey] = true;
  return cancel;
};

export default smoothScrollTo;